<template>
  <main class="Users">
    <PToolbar class="Users__Toolbar">
      <template #start>
        <AccountsMenu />
      </template>
      <template #end>
        <PButton
          :label="t('resource.user.create')"
          icon="pi pi-plus"
          class="p-button-outlined"
          @click="userForm.create"
        />
      </template>
    </PToolbar>

    <PDataTable
      :value="users"
      :total-records="totalRecords"
      :loading="loading"
      :rows="30"
      :row-hover="true"
      :row-class="() => 'UserItem'"
      paginator-template="CurrentPageReport FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink RowsPerPageDropdown"
      current-page-report-template=""
      responsive-layout="stack"
      lazy
      paginator
      show-gridlines
      :always-show-paginator="false"
      @page="nextPage"
      @row-click="userForm.update"
    >
      <PColumn field="name" :header="t('resource.user.name')"></PColumn>
      <PColumn field="email" :header="t('resource.user.email')"></PColumn>
      <PColumn field="roles" :header="t('resource.user.roles')">
        <template #body="{ data }">
          <Chip
            v-if="data.roles.includes(ROLE_ADMIN)"
            :label="t('resource.user.role_admin')"
            icon="mdi mdi-shield-crown-outline"
          />
        </template>
      </PColumn>
      <PColumn field="lockDate" :header="t('resource.user.status')">
        <template #body="{ data }">
          <span
            v-if="data.lockDate"
            class="mdi mdi-account-lock Users__Account Users__Account--locked"
            >{{
              t('resource.user.locked', {
                date: moment(data.lockDate).format('LL LT'),
              })
            }}</span
          >
          <span
            v-else
            class="mdi mdi-account Users__Account Users__Account--active"
            >{{ t('resource.user.active') }}</span
          >
        </template>
      </PColumn>
    </PDataTable>

    <UserDialog
      :user="userForm.target.value"
      @cancel="userForm.cancel"
      @create:user="userForm.onCreate"
      @update:user="userForm.onUpdate"
      @delete:user="userForm.onDelete"
    />
  </main>
</template>

<script lang="ts" setup>
import { BusinessCasesParams, User, userClient, ROLE_ADMIN } from '@/api'
import { onMounted, reactive, ref, toRaw, watch } from 'vue'
import { useI18n } from 'vue-i18n'
import UserDialog from './UserDialog.vue'
import Chip from 'primevue/chip/Chip.vue'
import moment from 'moment-timezone'
import { CurrentUser, DEFAULT_USER } from './useUser'
import AccountsMenu from '../AccountsMenu.vue'

const { t } = useI18n()
const totalRecords = ref<number>(0)
const users = ref<User[]>([])
const user = ref<User | null>(null)
const loading = ref<boolean>(false)
const queryParams = reactive<BusinessCasesParams>({
  page: 1,
})

const userForm = {
  /**
   * User created or updated
   */
  target: ref<CurrentUser>(null),

  /**
   * Create a new user
   */
  create: () => {
    userForm.target.value = DEFAULT_USER
  },

  /**
   * Updates an existing user
   */
  update: (event: { data: User }) => {
    userForm.target.value = event.data
  },

  /**
   * On user create by UserDialog
   */
  onCreate: (userCreated: User) => {
    users.value.unshift(userCreated)
    userForm.target.value = null
  },

  /**
   * On user update by UserDialog
   */
  onUpdate: (userUpdated: User) => {
    userForm.target.value = null
    for (const userIdx in users.value) {
      if (users.value[userIdx]?.id === userUpdated.id) {
        users.value[userIdx] = userUpdated
        return
      }
    }
  },

  /**
   * Remove deleted user from list
   */
  onDelete: (userId: User['id']) => {
    userForm.target.value = null
    let deletedIndex = users.value.findIndex((user) => user.id === userId)

    if (-1 !== deletedIndex) {
      users.value.splice(deletedIndex, 1)
    }
  },

  /**
   * Cancel current user action
   */
  cancel: () => {
    userForm.target.value = null
  },
}

/**
 * When user clicks on pagination, update page index in order to trigger API call
 */
function nextPage(event: { page: number }) {
  queryParams.page = event.page + 1 // event.page is zero-based, API is one-based
}

/**
 * Load paginated list of users
 */
async function loadUsers() {
  loading.value = true
  try {
    const { resources, total } = await userClient.getCollection(
      toRaw(queryParams)
    )
    totalRecords.value = total
    users.value = resources
  } finally {
    loading.value = false
  }
}

onMounted(loadUsers)
watch(queryParams, loadUsers)
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use 'src/pages/accounts/accountsView' as av;

.Users {
  @include av.accountsView();

  &__Account {
    &::before {
      margin-right: v.$spacing;
    }

    &--locked {
      color: var(--danger-color);
    }

    &--active {
      color: var(--success-color);
    }
  }
}
</style>
